// -*-c++-*-
/*
  The MIT License (MIT)

  Copyright (c) 2018 J. Eric Townsend

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/

/* basic stats with analogRead()

   intputs
   A0 photoresitro

   output
   D13 LED
   40 NEOPIXEL

*/

#include <Adafruit_NeoPixel.h>

#ifdef __AVR__
#include <avr/power.h>
#endif
#define PIN            40
#define NUMPIXELS      1
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRBW + NEO_KHZ800);

static const int statusLed = 13;
static const int buttonPin = 2;

unsigned int redVal = 255;

// these have to be signed so our difference test can return < 0
int redDuration = 0;
int redLedOn = 0;
int redLedStatus = 0;
long now = 0;

void setup() {
  Serial.begin(115200);

  pinMode(buttonPin, INPUT);

  pinMode(statusLed, OUTPUT);

  pixels.begin(); // This initializes the NeoPixel library.

  now = millis();
}

void loop() {

  now = millis();

  if (digitalRead(buttonPin) == HIGH) {
    Serial.println("HIGH");
    redDuration = now + 1000;
  }

  Serial.println(redDuration - now);
  if ((redDuration - now) > 0) {
    redLedOn = 1;
  }
  else {
    redLedOn = 0;
  }
  
  if ((redLedStatus ==0) && (redLedOn == 1)) {
    pixels.setPixelColor(0, pixels.Color(redVal, 0, 0));
    redLedStatus = 1;

  }
  else if (redLedOn == 0) {
    pixels.setPixelColor(0, pixels.Color(0, 0, 0));
    redLedStatus = 0;
  }
  
  pixels.show(); // This sends the updated pixel color to the hardware.
}
